package uk.co.badgersinfoil.metaas;

/**
 * Definition of a method parameter.
 * 
 * @see ASMethod#addParam(String, String)
 * @see ASMethod#getArgs()
 */
public interface ASArg {
	/**
	 * Returns the name of this ActionScript method argument
	 */
	public String getName();
	/**
	 * Returns the name of this parameter's type, or null if the parameter
	 * is untyped.
	 */
	public String getType();

	/**
	 * Defines the name of the type of object this parameter may
	 * reference.  May be set to null, denoting that the value is
	 * untyped.
	 */
	public void setType(String string);
}