package uk.co.badgersinfoil.metaas;

/**
 * A 'compilation unit' represents an entire file of ActionScript code.
 */
public interface CompilationUnit {
	/**
	 * Returns the name of the package, or null if the contents of the file
	 * are in the 'default' (top-level) package.
	 */
	public String getPackageName();

	/**
	 * Returns the type ({@link ASClassType} or {@link ASInterfaceType})
	 * which this file defines.
	 */
	public ASType getType();

	/**
	 * Modifies the name of the package containing the code of this
	 * compilation-unit.  Passing null causes the resulting code to be in
	 * the 'default' (top-level) package.
	 */
	public void setPackageName(String name);

	/**
	 * Returns the first ActionScript package-block declaired in this
	 * compilation-unit.
	 */
	public ASPackage getPackage();
}