package uk.co.badgersinfoil.metaas;

/**
 * Represents the access to a class mamber allowed from other classes, as
 * specified by the "public" and "private" modifiers (or lack of) in the
 * member's definition.
 */
public interface Visibility {

	/**
	 * Private access, as specified by the "private" modifier.
	 */
	public static final Visibility PRIVATE = new AccessVisibility("private");

	/**
	 * Public access, as specified by the "public" modifier.
	 */
	public static final Visibility PUBLIC = new AccessVisibility("public");

	/**
	 * Default access, as specified by the lack of either a "public or
	 * "private" modifier.
	 */
	public static final Visibility DEFAULT = new AccessVisibility("[default]");
}