package uk.co.badgersinfoil.metaas.impl;

import org.asdt.core.internal.antlr.AS3Parser;
import uk.co.badgersinfoil.metaas.ASSwitchStatement;
import uk.co.badgersinfoil.metaas.StatementContainer;
import uk.co.badgersinfoil.metaas.impl.antlr.LinkedListTree;


public class ASTASSwitchStatement implements ASSwitchStatement {

	private LinkedListTree ast;

	public ASTASSwitchStatement(LinkedListTree block) {
		ast = block;
	}

	public StatementContainer newCase(String expr) {
		LinkedListTree caseStmt = ASTUtils.newAST(AS3Parser.CASE, "case");
		caseStmt.appendToken(TokenBuilder.newSpace());
		caseStmt.addChildWithTokens(ASTUtils.parseExpr(expr));
		caseStmt.appendToken(TokenBuilder.newColon());
		LinkedListTree stmtList = ASTUtils.newImaginaryAST(AS3Parser.SWITCH_STATEMENT_LIST);
		caseStmt.addChildWithTokens(stmtList);
		ASTUtils.addChildWithIndentation(ast, caseStmt);
		return new ASTStatementList(stmtList);
	}

	public StatementContainer newDefault() {
		LinkedListTree defaultStmt = ASTUtils.newAST(AS3Parser.DEFAULT, "default");
		defaultStmt.appendToken(TokenBuilder.newColon());
		LinkedListTree stmtList = ASTUtils.newImaginaryAST(AS3Parser.SWITCH_STATEMENT_LIST);
		defaultStmt.addChildWithTokens(stmtList);
		ASTUtils.addChildWithIndentation(ast, defaultStmt);
		return new ASTStatementList(stmtList);
	}
}