package uk.co.badgersinfoil.metaas.impl;

import java.io.PrintWriter;
import java.io.Writer;
import uk.co.badgersinfoil.metaas.impl.antlr.LinkedListToken;
import uk.co.badgersinfoil.metaas.impl.antlr.LinkedListTree;


public class ASTPrinter {
	
	PrintWriter out;

	public ASTPrinter(Writer out) {
		this.out = new PrintWriter(out);
	}

	public void print(LinkedListTree ast) {
		for (LinkedListToken tok=findStart(ast); tok!=null; tok=tok.getNext()) {
			print(tok);
		}
	}

	private LinkedListToken findStart(LinkedListTree ast) {
		LinkedListToken result = null;
		for (LinkedListToken tok=ast.getStartToken(); viable(tok); tok=tok.getPrev()) {
			result = tok;
		}
		return result;
	}

	private boolean viable(LinkedListToken tok) {
		return tok != null && tok.getType() != LinkedListToken.EOF;
	}

	private void print(LinkedListToken tok) {
		if (tok.getText() != null) {
			out.write(tok.getText());
		}
	}
}